## liblinear 2.43+dfsg

=== Makefile ===
CXX ?= g++
CC ?= gcc
CFLAGS = -Wall -Wconversion -O3 -fPIC
LIBS = blas/blas.a
SHVER = 4
OS = $(shell uname)
#LIBS = -lblas

all: train predict

lib: linear.o newton.o blas/blas.a
	if [ "$(OS)" = "Darwin" ]; then \
		SHARED_LIB_FLAG="-dynamiclib -Wl,-install_name,liblinear.so.$(SHVER)"; \
	else \
		SHARED_LIB_FLAG="-shared -Wl,-soname,liblinear.so.$(SHVER)"; \
	fi; \
	$(CXX) $${SHARED_LIB_FLAG} linear.o newton.o blas/blas.a -o liblinear.so.$(SHVER)

train: newton.o linear.o train.c blas/blas.a
	$(CXX) $(CFLAGS) -o train train.c newton.o linear.o $(LIBS)

predict: newton.o linear.o predict.c blas/blas.a
	$(CXX) $(CFLAGS) -o predict predict.c newton.o linear.o $(LIBS)

newton.o: newton.cpp newton.h
	$(CXX) $(CFLAGS) -c -o newton.o newton.cpp

linear.o: linear.cpp linear.h
	$(CXX) $(CFLAGS) -c -o linear.o linear.cpp

blas/blas.a: blas/*.c blas/*.h
	make -C blas OPTFLAGS='$(CFLAGS)' CC='$(CC)';

clean:
	make -C blas clean
	make -C matlab clean
	rm -f *~ newton.o linear.o train predict liblinear.so.$(SHVER)

=== matlab/Makefile ===
# This Makefile is used under Linux

MATLABDIR ?= /usr/local/matlab
CXX ?= g++
#CXX = g++-3.3
CC ?= gcc
CFLAGS = -Wall -Wconversion -O3 -fPIC -I$(MATLABDIR)/extern/include -I..

MEX = $(MATLABDIR)/bin/mex
MEX_OPTION = CC="$(CXX)" CXX="$(CXX)" CFLAGS="$(CFLAGS)" CXXFLAGS="$(CFLAGS)"
# comment the following line if you use MATLAB on a 32-bit computer
MEX_OPTION += -largeArrayDims
MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)

all:	matlab

matlab:	binary

octave:
	@echo "please type make under Octave"
binary: train.$(MEX_EXT) predict.$(MEX_EXT) libsvmread.$(MEX_EXT) libsvmwrite.$(MEX_EXT)

train.$(MEX_EXT): train.c ../linear.h ../newton.cpp ../linear.cpp linear_model_matlab.c \
		../blas/daxpy.c ../blas/ddot.c ../blas/dnrm2.c ../blas/dscal.c
	$(MEX) $(MEX_OPTION) train.c ../newton.cpp ../linear.cpp linear_model_matlab.c \
		../blas/daxpy.c ../blas/ddot.c ../blas/dnrm2.c ../blas/dscal.c

predict.$(MEX_EXT): predict.c ../linear.h ../newton.cpp ../linear.cpp linear_model_matlab.c \
		../blas/daxpy.c ../blas/ddot.c ../blas/dnrm2.c ../blas/dscal.c
	$(MEX) $(MEX_OPTION) predict.c ../newton.cpp ../linear.cpp linear_model_matlab.c \
		../blas/daxpy.c ../blas/ddot.c ../blas/dnrm2.c ../blas/dscal.c

libsvmread.$(MEX_EXT):	libsvmread.c
	$(MEX) $(MEX_OPTION) libsvmread.c

libsvmwrite.$(MEX_EXT):	libsvmwrite.c
	$(MEX) $(MEX_OPTION) libsvmwrite.c

clean:
	rm -f *~ *.o *.mex* *.obj

=== debian/changelog ===
liblinear (2.43+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - This release bumps the SONAME.
    - The Python modules liblinear, liblinearutil have been moved into a
      package liblinear.
  * Drop patches included upstream, refresh other patches
  * Drop Merge-commonutil.py-into-liblinearutil.py.patch (commonutil is no
    longer in the global namespace)
  * Add patch Bump-SHVER-to-5.patch
  * Update symbols file
  * Rename liblinear4 -> liblinear5
  * Update liblinear-train.1
  * Update d/watch
  * Update autopkgtest for new Python package
  * Fix version parsing in d/rules (after d/watch update)
  * Bump Standards-Version to 4.6.0 (no changes needed)
  * Bump debhelper compatibility to 13
  * Drop lintian-overrides for obsolete tag

 -- Christian Kastner <ckk@debian.org>  Mon, 07 Mar 2022 18:13:44 +0100

=== debian/control ===
Source: liblinear
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christian Kastner <ckk@debian.org>,
           Chen-Tse Tsai <ctse.tsai@gmail.com>,
           Michael Hudson-Doyle <mwhudson@debian.org>,
Build-Depends: debhelper-compat (= 13), libblas-dev
Build-Depends-Indep: dh-python, python3-all
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://www.csie.ntu.edu.tw/~cjlin/liblinear/
Vcs-Git: https://salsa.debian.org/science-team/liblinear.git
Vcs-Browser: https://salsa.debian.org/science-team/liblinear

Package: liblinear-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libblas-dev | libblas.so,
         liblinear5 (= ${binary:Version}),
         ${misc:Depends},
Description: Development libraries and header files for LIBLINEAR
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around.
 .
 This package contains the header files and static libraries.

Package: liblinear5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: liblinear-dev (= ${binary:Version}),
          liblinear-tools (= ${binary:Version}),
Description: Library for Large Linear Classification
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around. It also provides Python bindings.
 .
 This package contains the shared libraries.

Package: liblinear-tools
Section: science
Architecture: any
Multi-Arch: foreign
Depends: liblinear5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Suggests: libsvm-tools
Description: Standalone applications for LIBLINEAR
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around. It also provides Python bindings.
 .
 This package contains the standalone applications.

Package: python3-liblinear
Section: python
Architecture: all
Depends: liblinear5 (<< ${binary:Version}.1~),
         liblinear5 (>= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
Description: Python 3 bindings for LIBLINEAR
 LIBLINEAR is a library for learning linear classifiers for large scale
 applications. It supports Support Vector Machines (SVM) with L2 and L1
 loss, logistic regression, multi class classification and also Linear
 Programming Machines (L1-regularized SVMs). Its computational complexity
 scales linearly with the number of training examples making it one of
 the fastest SVM solvers around. It also provides Python bindings.
 .
 This package contains the Python 3 bindings.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# For DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

# Needed for our Makefile customizations
DMAJOR := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -rne 's/([0-9])\.[0-9]+.*/\1/p')
DMINOR := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -rne 's/[0-9]\.([0-9]+).*/\1/p')
DPATCH := 0
export DMAJOR DMINOR DPATCH


export DEB_BUILD_MAINT_OPTIONS += hardening=+all
export DEB_CFLAGS_MAINT_APPEND += -Wall

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
ifeq (amd64,$(DEB_HOST_ARCH))
    DEB_CFLAGS_MAINT_APPEND += -msse
endif
endif


%:
	dh $@ $(DH_ADDONS)
build binary %-indep: DH_ADDONS=--with=python3


override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/

=== debian/watch ===
version=4

# ckk 2022-03-05: deactivate this, it hasn't been relevant for a long time
# Upstream's versioning scheme is 1.0, 1.01, 1.1, 1.11, 1.12, etc., so we
# mangle it by converting it to x.y.z pattern:
#  1.0   -> 1.0.0
#  1.01  -> 1.0.1
#  1.1   -> 1.1.0
#  1.11  -> 1.1.1
#  1.12  -> 1.1.2
#  etc
#uversionmangle=s/(\d\.\d)$/${1}0/;s/(\d)\.(\d)(\d)/${1}\.${2}\.${3}/,\

opts=\
dversionmangle=s/\+dfsg//,\
repacksuffix=+dfsg \
https://www.csie.ntu.edu.tw/~cjlin/liblinear/oldfiles/liblinear-(.*)\.tar\.gz
